/*
** $VER UpTime.c 1.1 (26.2.97)
** Copyright 1997 Mark Rigby-Jones
** mrj@ox.compsoc.org.uk.uk <*> http://www.ox.compsoc.org.uk/~mrj/
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** If you do not have a copy of the GNU General Public License then
** you can get one by writing to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <devices/timer.h>
#include <clib/timer_protos.h>

UBYTE *ver = "\0$VER: UpTime 1.1 (26.2.97)";

main()
{
    ULONG frequency, mins, hours, upsecs, upmins, uphours, updays;
    char am_pm;
    struct timeval *time;
    struct EClockVal *uptime;
    GetSysTime(time);
    mins = time->tv_secs / 60;
    hours = mins / 60;
    mins = mins % 60;
    hours = hours % 24;
    if (hours > 11) {
        hours -= 12;
        am_pm = 'p';
    } else {
        am_pm ='a';
    }
    if (hours == 0) {
        hours = 12;
    }
    printf(" %2d:%02d%cm  up ", hours, mins, am_pm);
    frequency = ReadEClock(uptime);
    upsecs = uptime->ev_hi * 2 * (2147483648 / frequency) + uptime->ev_lo / frequency;
    upmins = upsecs / 60;
    uphours = upmins / 60;
    upmins = upmins % 60;
    updays = uphours /24;
    uphours = uphours % 24;
    if (updays > 0) {
        if (updays == 1) {
            printf("1 day, ");
        } else {
            printf("%d days, ", updays);
        }
    }
    if (uphours == 0) {
        printf("%d min", upmins);
    } else {
        printf("%2d:%02d", uphours, upmins);
    }
    printf(",  1 user,  load average: 0.00, 0.00, 0.00\n");
    return(0);
}

